const db = require('../db/models');
const ValidationError = require('./notifications/errors/validation');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

/**
 * @param {string} permission
 * @param {object} currentUser
 */
async function checkPermissions(permission, currentUser) {
  if (!currentUser) {
    throw new ValidationError('auth.unauthorized');
  }

  const userPermission = currentUser.custom_permissions.find(
    (cp) => cp.name === permission,
  );

  if (userPermission) {
    return true;
  }

  try {
    if (!currentUser.app_role) {
      throw new ValidationError('auth.forbidden');
    }

    const permissions = await currentUser.app_role.getPermissions();

    return !!permissions.find((p) => p.name === permission);
  } catch (e) {
    throw e;
  }
}

module.exports = class SearchService {
  static async search(searchQuery, currentUser, organizationId, globalAccess) {
    try {
      if (!searchQuery) {
        throw new ValidationError('iam.errors.searchQueryRequired');
      }
      const tableColumns = {
        users: ['firstName', 'lastName', 'phoneNumber', 'email'],

        cameras_ptz: [
          'modelo',

          'fabricante',

          'local_instalacao',

          'angulo_focal',

          'ip_acesso',

          'status_operacional',

          'observacoes',
        ],

        epcs: ['nome_epc', 'descricao'],

        epis: ['nome_epi', 'descricao'],

        equipes_trabalho: ['nome_equipe'],

        estrutura_projeto: ['etapa', 'atividade', 'descricao'],

        etapas_ou_trechos: ['tipo', 'nome', 'descricao'],

        frames_imagem: ['imagem_url', 'observacoes'],

        gemeos_digitais: ['tipo', 'arquivo_url', 'descricao'],

        historico_alteracoes_projeto: [
          'tipo_alteracao',

          'descricao_anterior',

          'descricao_nova',

          'motivo_alteracao',

          'responsavel_alteracao',

          'comentarios',
        ],

        inspecao_aerea: ['tipo_inspecao', 'observacoes'],

        maquinas_atividade: ['comentarios'],

        materiais_atividade: ['unidade_medida', 'comentarios'],

        membros_equipe: ['nome', 'funcao'],

        memoriais_descritivos_asbuilt: [
          'titulo',

          'descricao',

          'arquivo_digital',

          'responsavel_tecnico',

          'comentarios_validacao',
        ],

        modelos_bim_asbuilt: [
          'nome_modelo',

          'descricao',

          'arquivo_modelo',

          'formato',

          'plataforma_origem',

          'responsavel_modelagem',

          'nivel_detalhamento',

          'comentarios',
        ],

        obras: ['nome_obra', 'cidade', 'estado', 'descricao'],

        permissoes_modulo: ['modulo'],

        pessoas_atividade: ['funcao_na_atividade', 'comentarios'],

        pessoas_frame: ['atividade', 'posicao_aproximada', 'epi_visiveis'],

        plantas_asbuilt_2d: [
          'nome_planta',

          'descricao',

          'arquivo_digital',

          'formato',

          'responsavel_tecnico',

          'sistema_referencia',

          'comentarios',
        ],

        relatorio_andamento_atual: [
          'status_obra',

          'atividade_atual_predominante',

          'riscos_em_aberto',

          'tempo_estimado_para_conclusao',

          'grau_conformidade_geral',

          'observacoes_finais',
        ],

        relatorios_analiticos_video: ['json_analise'],

        relatorios_diarios: ['resumo'],

        relatorios_mensais: ['resumo'],

        relatorios_semanais: ['resumo'],

        subcontratadas: ['nome', 'cnpj', 'endereco', 'responsavel_tecnico'],

        usuarios: ['nome', 'email', 'senha_hash'],

        clientes: ['name'],
      };
      const columnsInt = {
        cameras_ptz: [
          'coordenada_lat',

          'coordenada_lon',

          'altura_instalacao_m',
        ],

        estrutura_projeto: ['prazo_estimado_dias'],

        maquinas_atividade: [
          'quantidade_prevista',

          'horas_utilizacao_previstas',
        ],

        materiais_atividade: ['quantidade_prevista', 'tolerancia_estoque'],

        pessoas_atividade: ['horas_previstas'],

        relatorio_andamento_atual: ['percentual_execucao_total'],
      };

      let allFoundRecords = [];

      for (const tableName in tableColumns) {
        if (tableColumns.hasOwnProperty(tableName)) {
          const attributesToSearch = tableColumns[tableName];
          const attributesIntToSearch = columnsInt[tableName] || [];
          const whereCondition = {
            [Op.or]: [
              ...attributesToSearch.map((attribute) => ({
                [attribute]: {
                  [Op.iLike]: `%${searchQuery}%`,
                },
              })),
              ...attributesIntToSearch.map((attribute) =>
                Sequelize.where(
                  Sequelize.cast(
                    Sequelize.col(`${tableName}.${attribute}`),
                    'varchar',
                  ),
                  { [Op.iLike]: `%${searchQuery}%` },
                ),
              ),
            ],
          };

          if (
            !globalAccess &&
            tableName !== 'organizations' &&
            organizationId
          ) {
            whereCondition.organizationId = organizationId;
          }

          const hasPermission = await checkPermissions(
            `READ_${tableName.toUpperCase()}`,
            currentUser,
          );
          if (!hasPermission) {
            continue;
          }

          const foundRecords = await db[tableName].findAll({
            where: whereCondition,
            attributes: [
              ...tableColumns[tableName],
              'id',
              ...attributesIntToSearch,
            ],
          });

          const modifiedRecords = foundRecords.map((record) => {
            const matchAttribute = [];

            for (const attribute of attributesToSearch) {
              if (
                record[attribute]
                  ?.toLowerCase()
                  ?.includes(searchQuery.toLowerCase())
              ) {
                matchAttribute.push(attribute);
              }
            }

            for (const attribute of attributesIntToSearch) {
              const castedValue = String(record[attribute]);
              if (
                castedValue &&
                castedValue.toLowerCase().includes(searchQuery.toLowerCase())
              ) {
                matchAttribute.push(attribute);
              }
            }

            return {
              ...record.get(),
              matchAttribute,
              tableName,
            };
          });

          allFoundRecords = allFoundRecords.concat(modifiedRecords);
        }
      }

      return allFoundRecords;
    } catch (error) {
      throw error;
    }
  }
};
